樂猪先生

CentOS安装RabbitMQ及PHP扩展

2017-12-18

开发环境

CentOS7.3

安装RabbitMQ服务端

1
sudo yum install rabbitmq-server

安装完成后可以使用systemctl系列命令进行管理操作

1
systemctl start rabbitmq-server #启动mq

安装rabbitmq-c

在安装amqp之前还需要安装另外一个通讯扩展rabbitmq-c。
github下载最新版本(目前是0.8.0)的源码包并解压缩。

1
2
3
4
5
6
7
8
9
cd rabbitmq-c-0.8.0/
mkdir build && cd build #这一步是在rabbitmq-c的根目录下创建一个build子目录

# 这一步是让cmake根据../CMakeList.txt,即rabbitmq-c的根目录下的CMakeList.txt创建Makefile文件
# Makefile文件会被创建到build目录中
cmake -DCMAKE_INSTALL_PREFIX=/usr/local/rabbitmq-c ..

# 这一步是真正的build rabbitmq-c库的,注意,不要漏掉点 '.'
cmake --build . --target install

到这里就已经安装完成了。不过这里有一个。你可以看一下/usr/local/rabbitmq-c下的目录只有includelib64。因为后面编译安装amqp扩展的时候系统会到/usr/local/rabbitmq-c/lib目录下搜索依赖库,导致错误。所以这里需要加一步:

1
ln -s lib64 lib

安装amqp

  1. 从pecl官方库中下载最新的amqp扩展包

    1
    wget https://pecl.php.net/get/amqp-1.9.3.tgz
  2. 解压并编译安装

    1
    2
    3
    4
    cd amqp-1.9.3
    phpize
    ./configure --with-php-config=/usr/local/php/bin/php-config --with-amqp --with-librabbitmq-dir=/usr/local/rabbitmq-c
    make && make install

配置amqp扩展

1
2
vi /usr/local/php/etc/php.ini
添加 extension=amqp.so

2018-06-06更新

在Ubuntu16.04(homestead环境)上安装php的amqp扩展的时候执行如下命令

1
./configure --with-php-config=/usr/bin/php-config5.6 --with-amqp --with-librabbitmq-dir=/usr/local/rabbitmq-c

出现如下错误

1
2
3
4
5
libtool: link: cc -shared  -fPIC -DPIC  .libs/amqp.o .libs/amqp_type.o .libs/amqp_exchange.o .libs/amqp_queue.o .libs/amqp_connection.o .libs/amqp_connection_resource.o .libs/amqp_channel.o .libs/amqp_envelope.o .libs/amqp_basic_properties.o .libs/amqp_methods_handling.o .libs/amqp_timestamp.o .libs/amqp_decimal.o   -L/usr/local/rabbitmq-c/lib -lrabbitmq  -g -O2 -Wl,-rpath -Wl,/usr/local/rabbitmq-c/lib   -Wl,-soname -Wl,amqp.so -o .libs/amqp.so
/usr/bin/ld: cannot find -lrabbitmq
collect2: error: ld returned 1 exit status
Makefile:208: recipe for target 'amqp.la' failed
make: *** [amqp.la] Error 1

从错误可以看到重要的一段是/usr/bin/ld: cannot find -lrabbitmq。意思就是无法找到我们上面安装的rabbitmq-c库。然后我去/usr/local/rabbitmq-c目录里执行ls命令后发现也确实只有includelib目录。

到这里我真的是百思不得其解,然后我又试着查看了lib目录里的内容,发现竟然还有个目录,目录名为x86_64-linux-gnu在这里目录里才是我们要的库文件

1
2
3
4
5
6
7
drwxr-xr-x 3 root root   4096 Jun  6 05:32 ./
drwxr-xr-x 4 root root 4096 Jun 6 05:49 ../
-rw-r--r-- 1 root root 164284 Jun 6 05:32 librabbitmq.a
lrwxrwxrwx 1 root root 16 Jun 6 05:32 librabbitmq.so -> librabbitmq.so.4
lrwxrwxrwx 1 root root 20 Jun 6 05:32 librabbitmq.so.4 -> librabbitmq.so.4.2.0
-rw-r--r-- 1 root root 111400 Jun 6 05:32 librabbitmq.so.4.2.0
drwxr-xr-x 2 root root 4096 Jun 6 05:32 pkgconfig/

于是我执行了cp -r x86_64-linux-gnu/* .把这里目录下的所有文件拷贝到上一层。然后继续执行

1
./configure --with-php-config=/usr/bin/php-config5.6 --with-amqp --with-librabbitmq-dir=/usr/local/rabbitmq-c

发现可以正确的安装了。

小结:
之前是在CentOS上安装的,最近使用Homestead开发环境,用的是Ubuntu16.04。系统不一样导致编译出的rabbitma-c目录下多了平台相关的文件夹。而CentOS上则是直接编译到了rabbitmq-c根目录下。